
/****************************************************
 Find all shortest-paths from pV to pSource
 "threshold" influences the number of alternative pathways
Precondition:  weighted, un-directional graph
Postcondition:  0 means no path
                1 means successful
Problems:   memory leak?
*****************************************************/
/*
int Dijkstra::find_all_shortest_paths_w( Node* pV,
    std::vector< std::vector<Node*> *> & vpvpReturnPaths, float threshold) {
  int debug =1;
  unsigned isConverged = 0;

  if (debug) {cout <<"(w) pV->pId="<<pV->pId<< " vpvpReturnPaths.size()="<< vpvpReturnPaths.size()<<endl; }

  if ( pV->nD == dMAX ) {
      if (debug) { cout <<"Target is "<<pV->pId<<".  There is no path. Bye "<<endl; }
      return 0;
  }

  // initiate vpvpReturnPaths with pV
  std::vector<Node*> * pvpTMP = new std::vector<Node*> ;
  pvpTMP->push_back( pV );  //this is the end point for trace back
  vpvpReturnPaths.push_back( pvpTMP );

  if ( pV->nD == 0) { return 1; }

  if (debug) { cout <<"(w) vpvpReturnPaths.size()="<< vpvpReturnPaths.size()<<endl; }

  while ( isConverged == 0 ) {
    std::vector< std::vector<Node*> * > vpvpNewPaths = vpvpReturnPaths;
    // cout << "(in w) while loop" <<endl;
    for (unsigned i=0; i< vpvpReturnPaths.size(); ++i) { //enumerate all paths
        // cout << "(in w) i loop" << endl;
	    std::vector<Node*> * pvCurrentPath =  vpvpNewPaths[i];
        Node * pCurrentNode = (* pvCurrentPath)[ pvCurrentPath->size() - 1]; //this is current leaf node

        //find out next available moves
        std::deque< Node* > dpNextNodes;
        if( pCurrentNode->nD >0 ) {
            for( unsigned j=0; j< pCurrentNode->vpNeighbors.size(); ++j) {
                if ( _is_there( pCurrentNode->vpNeighbors[j], pvCurrentPath ) == 0 ) {
                    //float delta = pCurrentNode->nD - pCurrentNode->vnWeights[j];  //!!!!!!!!
                    if ( pCurrentNode->vpNeighbors[j]->nD <= ( pCurrentNode->nD + threshold) ) { //potential loop? cannot deal with zero distance.
                        dpNextNodes.push_back( pCurrentNode->vpNeighbors[j] );
                        cout <<"(w) next:"<< pCurrentNode->vpNeighbors[j]->pId << endl;
                    }
                }
            }//j
        }

        cout << "(in w) after finding dpNextNodes" <<endl;
        //update the paths
        if ( dpNextNodes.size() > 1 ) {
			//the number of path is increased here.
            for( unsigned k=1; k<dpNextNodes.size(); ++k) {
                std::vector<Node*> * pvpTMP2 = new std::vector<Node*>;  // a new path
                (*pvpTMP2) = ( * pvCurrentPath );       // copy the known steps
                pvpTMP2->push_back( dpNextNodes[k] );  // add the new step
                vpvpNewPaths.push_back( pvpTMP2 );     // I cannot insert after i-th path, because it destroys iteration sequence.
                // how free pvpTMP2?
            }
            pvCurrentPath->push_back( dpNextNodes[0] );  // the old path,
        } else if ( dpNextNodes.size()==1 ) {
			// only one addition
			pvCurrentPath->push_back( dpNextNodes[0] );
        } else {
            /*** no move, i-th path is no good. **/
            i
        }//fi
    }//i

    cout <<"(w) vpvpNewPaths.size()="<< vpvpNewPaths.size()<<endl;

    cout << "(w) before check vnSumPathWeights"<<endl;

    /** check the total length of each path, remove if they wildly exceed pV->nD **/
    std::vector<float> vnSumPathWeights;
    vnSumPathWeights.reserve( vpvpNewPaths.size() );
    for( unsigned i=0; i<vpvpNewPaths.size(); ++i) {
        std::vector<Node*> * pvCurrentPath =  vpvpNewPaths[i];
        float sum = 0;
        cout <<"(w)pvCurrentPath->size() ="<< pvCurrentPath->size() <<endl;
        _print_path( pvCurrentPath );
        for( unsigned j=1; j<pvCurrentPath->size(); ++j) {
            sum = sum + _find_weight_bw_nodes( (*pvCurrentPath)[j-1], (*pvCurrentPath)[j] ); //??
            //cout <<"(w)sum=" << sum << endl;
        }
        vnSumPathWeights.push_back(sum);
    }

	/** check and update isCoverged; **/
    //isConverged = _check_convergence( & vpvpReturnPaths );
    isConverged=1;  // initialization
    if( vpvpNewPaths.size() > 1 ) {

        /** pick out the good paths**/
        vpvpReturnPaths.clear();
        for( unsigned i=0; i<vpvpNewPaths.size(); ++i) {
            if ( vnSumPathWeights[i] < ( pV->nD + threshold )) {
                cout << "vnSumPathWeights[i]=" << vnSumPathWeights[i];
                cout << " ( pV->nD + threshold )=" << ( pV->nD + threshold )<<endl;
                vpvpReturnPaths.push_back( vpvpNewPaths[i] );
            }
        }

        cout <<"(w) vpvpReturnPaths.size()="<< vpvpReturnPaths.size()<<endl;
        cout <<"(w) before update isConverged"<<endl;

        for( unsigned i=0; i< (vpvpReturnPaths.size()-1); ++i ) {
            std::vector<Node*> * pvPathOne =  vpvpReturnPaths[i];
            for( unsigned j=i; j<vpvpReturnPaths.size(); ++j ) {
                std::vector<Node*> * pvPathTwo =  vpvpReturnPaths[j];
                Node * pEndOne = (* pvPathOne)[pvPathOne->size()-1];
                Node * pEndTwo = (* pvPathTwo)[pvPathTwo->size()-1];
                if ( (string) pEndOne->pId != (string) pEndTwo->pId) { // is this necessary?
                    isConverged=0;  // no
                }
            }
            //compare end with target
            if ( (*pvPathOne)[pvPathOne->size()-1]->nD != 0 ) {
                isConverged = 0;
            }

        }//for
    } else { //only one path, compare with target
        std::vector<Node*> * pvPathOne =  vpvpReturnPaths[0];
        if ( (*pvPathOne)[pvPathOne->size()-1]->nD != 0 ) {
            isConverged = 0;
        }
    }
    cout <<"(w) isConverged=" <<isConverged <<endl;
  }//while

  return 1;
}
*/

